package aritmetika;

/**
 * Kompleksno število v kartezičnih koordinatah.
 * @author Andrej Bauer
 *
 */
public class KompleksnoKartezicno implements Kompleksno {
	/**
	 * realna komponenta
	 */
	private double re;
	
	/**
	 * imaginarna komponenta
	 */
	private double im;

	public KompleksnoKartezicno(double re, double im) {
		super();
		this.re = re;
		this.im = im;
	}

	public KompleksnoKartezicno(double re) {
		super();
		this.re = re;
		this.im = 0.0;
	}

	/**
	 * Kompleksno število v kartezičnih koordinatah, podano s polarnimi koordinatami
	 * @param abs absolutna vrednost
	 * @param arg argument
	 * @return
	 */
	public static KompleksnoKartezicno kompleksnoPolarno(double abs, double arg) {
		return new KompleksnoKartezicno(abs * Math.cos(arg), abs * Math.sin(arg));
	}
	
	public String toString() {
		return "Kompleksno [re=" + re + ", im=" + im + "]";
	}

	public Kompleksno mul(Kompleksno other) {
		double x = this.re * other.re() - this.im * other.im();
		double y = this.re * other.im() + this.im * other.re();
		return new KompleksnoKartezicno(x, y);
	}

	public double re() {
		return this.re;
	}

	public double im() {
		return this.im;
	}

	public double abs() {
		return Math.sqrt(re * re + im * im);
	}

	public double arg() {
		return Math.atan2(this.im, this.re);
	}

	/**
	 * @return kvadrat števila
	 */
	public Kompleksno sqr() {
		return this.mul(this);
	}
}
