package aritmetika;

public class KompleksnoPolarno implements Kompleksno {
	/**
	 * absolutna vrednost
	 */
	private double abs;
	
	/**
	 * argument
	 */
	private double arg;

	/**
	 * Absolutna vrednost mora biti nenegativna. Kdor tega ne bo upošteval,
	 * je sam kriv za nastalo zmedo.
	 * 
	 * @param abs absolutna vrednost
	 * @param arg argument
	 */
	public KompleksnoPolarno(double abs, double arg) {
		super();
		this.abs = abs;
		this.arg = arg;
	}

	public String toString() {
		return "Kompleksno [abs=" + abs + ", arg=" + (arg/Math.PI) + " * π]";
	}

	public double re() {
		return this.abs * Math.cos(this.arg);
	}

	public double im() {
		return this.abs * Math.sin(this.arg);
	}

	public double abs() {
		return this.abs;
	}

	public double arg() {
		return this.arg;
	}

	public Kompleksno mul(Kompleksno other) {
		double abs = this.abs * other.abs();
		double arg = this.arg + other.arg();
		return new KompleksnoPolarno(abs, arg);
	}

}
